# class NilClass

The class of the singleton object `nil`.

### Public Instance Methods

false & obj → false click to toggle source
nil & obj → false

And—Returns `false`. obj is always evaluated as it is the argument to a method call—there is no short-circuit evaluation in this case.

    static VALUE
    false_and(VALUE obj, VALUE obj2)
    {
        return Qfalse;
    }

obj === other → true or false click to toggle source

Case Equality – For class `Object`, effectively the same as calling `#==`, but typically overridden by descendants to provide meaningful semantics in `case` statements.

    #define case_equal rb_equal

nil =~ other → nil click to toggle source

Dummy pattern matching – always returns nil.

This method makes it possible to ‘while gets =~ /re/ do`.

    static VALUE
    nil_match(VALUE obj1, VALUE obj2)
    {
        return Qnil;
    }

false ^ obj → true or false click to toggle source
nil ^ obj → true or false

Exclusive Or—If obj is `nil` or `false`, returns `false`; otherwise, returns `true`.

    #define false_xor true_and

inspect → "nil" click to toggle source

Always returns the string “nil”.

    static VALUE
    nil_inspect(VALUE obj)
    {
        return rb_usascii_str_new2("nil");
    }

nil? → true click to toggle source

Only the object nil responds `true` to `nil?`.

    static VALUE
    rb_true(VALUE obj)
    {
        return Qtrue;
    }

rationalize([eps]) → (0/1) click to toggle source

Returns zero as a rational. The optional argument `eps` is always ignored.

    static VALUE
    nilclass_rationalize(int argc, VALUE *argv, VALUE self)
    {
        rb_check_arity(argc, 0, 1);
        return nilclass_to_r(self);
    }

to_a → [] click to toggle source

Always returns an empty array.

    nil.to_a   #=> []

    static VALUE
    nil_to_a(VALUE obj)
    {
        return rb_ary_new2(0);
    }

to_c → (0+0i) click to toggle source

Returns zero as a complex.

    static VALUE
    nilclass_to_c(VALUE self)
    {
        return rb_complex_new1(INT2FIX(0));
    }

to_d → bigdecimal click to toggle source

Returns nil represented as a `BigDecimal`.

    require 'bigdecimal'
    require 'bigdecimal/util'

    nil.to_d   # => 0.0

    # File ext/bigdecimal/lib/bigdecimal/util.rb, line 182
    def to_d
      BigDecimal(0)
    end

to_f → 0.0 click to toggle source

Always returns zero.

    nil.to_f   #=> 0.0

    # File nilclass.rb, line 22
    def to_f
      return 0.0
    end

to_h → {} click to toggle source

Always returns an empty hash.

    nil.to_h   #=> {}

    static VALUE
    nil_to_h(VALUE obj)
    {
        return rb_hash_new();
    }

to_i → 0 click to toggle source

Always returns zero.

    nil.to_i   #=> 0

    # File nilclass.rb, line 10
    def to_i
      return 0
    end

to_r → (0/1) click to toggle source

Returns zero as a rational.

    static VALUE
    nilclass_to_r(VALUE self)
    {
        return rb_rational_new1(INT2FIX(0));
    }

to_s → "" click to toggle source

Always returns the empty string.

    MJIT_FUNC_EXPORTED VALUE
    rb_nil_to_s(VALUE obj)
    {
        return rb_cNilClass_to_s;
    }

false | obj → true or false click to toggle source
nil | obj → true or false

Or—Returns `false` if obj is `nil` or `false`; `true` otherwise.

    #define false_or true_and